rebol [
    title: "PuReP0NG"
    version: 0.7
    date: 23/08/2003
    author: "Sbastien 'Jedi' Jeudy"
    email: s.jeudy@libertysurf.fr
    url: http://reboleur.free.fr
]


; variables gnrales
taille-ecran: 640x480
;taille-ecran: 800x600
fond-ecran: load %fond640.jpg taille-ecran
taille-titre: 0x25
taille-titre/x: taille-ecran/x
offset-souris: 20
taille-raquette: 24x100
raquette: load %raquette.bmp
coeff-lift: 3
score-max: 3
ip: 0.0.0.0
port: 0
donnees-serveur: []
donnees-P1: []
donnees-P2: []

; variables de la raquette1
pos-raquette1: 0x0
pos-raquette1/x: taille-ecran/x - 40
pos-raquette1/y: (taille-ecran/y / 2) - (taille-raquette/y / 2)
pos-souris: pos-raquette1
diff-raquette1: 0
inc-raquette1: 0x0
vit-raquette1: 50
score1: 0

; variables de la raquette2
pos-raquette2: 15x0
pos-raquette2/y: pos-raquette1/y
pos-clavier: pos-raquette2
diff-raquette2: 0
inc-raquette2: 0x0
vit-raquette2: 50
score2: 0

; variables de la balle
depart-balle: 0x0
depart-balle/x: taille-ecran/x / 2
depart-balle/y: pos-raquette1/y
pos-balle: depart-balle
taille-balle: 45
balle: load %balle.bmp
init-inc-balle: 30x0
inc-balle: init-inc-balle


demarrage-connexion: does [
    ; dmarrage de la connexion rseau
    connexion: open to-url join "udp://" [ ip ":" port ]
]


demarrage-partie: does [
    ; en rseau, dmarrage de la partie quand l'autre joueur a aussi dmarr sa partie
    insert connexion "P1_NON_0x0"
    insert connexion "P2_NON_0x0"
    partie-OK: false
    until [
        either player1/data = true [
            insert connexion "P1_CNX_0x0"
            donnees-serveur: parse (copy connexion) "_"
            donnees-P1: copy/part (find donnees-serveur "P1") 2
            donnees-P2: copy/part (find donnees-serveur "P2") 2
            if all [ ((second donnees-P1) = "CNX") ((second donnees-P2) = "CNX") ] [ partie-OK: true]
        ] [ insert connexion "P2_CNX_0x0"
            donnees-serveur: parse (copy connexion) "_"
            donnees-P1: copy/part (find donnees-serveur "P1") 2
            donnees-P2: copy/part (find donnees-serveur "P2") 2
            if all [ ((second donnees-P1) = "CNX") ((second donnees-P2) = "CNX") ] [ partie-OK: true]
        ]
        (partie-OK = true)
    ]
]


gestion-connexion: does [
    ; gestion de la connexion
    either player1/data = true [
        ; envoi des donnes player1 au serveur
        insert connexion reduce [ "P1_CNX_" (to-string pos-souris) ]
    ] [
        ; envoi des donnes player2 au serveur
        insert connexion reduce [ "P2_CNX_" (to-string pos-souris) ]
    ]

    ; rception des donnes du serveur
    clear donnees-serveur
    donnees-serveur: parse (copy connexion) "_"
    pos-raquette1: to-pair (pick donnees-serveur 5)
    pos-balle: to-pair (pick donnees-serveur 6)
    pos-raquette2: to-pair (pick donnees-serveur 7)
    score1: to-integer (pick donnees-serveur 8)
    score2: to-integer (pick donnees-serveur 9)
]


gestion-pong: does [
    ; gestion de pong
    ; si pas de rseau
    either reseau/data = false [
 
    ; gestion de la raquette1
    either player1/data = true [
        ; souris
        diff-raquette1: pos-souris/y + offset-souris - (pos-raquette1/y + taille-raquette/y)
        lift1: (-1 * diff-raquette1) / coeff-lift
        either diff-raquette1 >= 0 [
            either diff-raquette1 > vit-raquette1 [
                inc-raquette1/y: vit-raquette1
            ] [ inc-raquette1/y: diff-raquette1 ]
        ] [ diff-raquette1: negate diff-raquette1
            either diff-raquette1 > vit-raquette1 [
                inc-raquette1/y: negate vit-raquette1
            ] [ inc-raquette1/y: negate diff-raquette1 ]
        ]
        pos-raquette1: pos-raquette1 + inc-raquette1
    ] [ if homme/data = true [
            ; clavier
            diff-raquette1: pos-clavier/y + (taille-balle / 2) - (pos-raquette1/y + (taille-raquette/y / 2))
            lift1: (-1 * diff-raquette1) / coeff-lift
            pos-raquette1: pos-clavier
        ] 
        if machine/data = true [
            ; machine
            diff-raquette1: pos-balle/y + (taille-balle / 2) - (pos-raquette1/y + (taille-raquette/y / 2))
            lift1: (-1 * diff-raquette1) / coeff-lift
            either diff-raquette1 >= 0 [
                either diff-raquette1 > vit-raquette1 [
                    inc-raquette1/y: vit-raquette1
                ] [ inc-raquette1/y: diff-raquette1 ]
            ] [ diff-raquette1: negate diff-raquette1
                either diff-raquette1 > vit-raquette1 [
                    inc-raquette1/y: negate vit-raquette1
                ] [ inc-raquette1/y: negate diff-raquette1 ]
            ]
            pos-raquette1: pos-raquette1 + inc-raquette1
        ]
    ]

    ; gestion de la raquette2
    either player2/data = true [
        ; souris
        diff-raquette2: pos-souris/y + offset-souris - (pos-raquette2/y + taille-raquette/y)
        lift2: (-1 * diff-raquette2) / coeff-lift
        either diff-raquette2 >= 0 [
            either diff-raquette2 > vit-raquette2 [
                inc-raquette2/y: vit-raquette2
            ] [ inc-raquette2/y: diff-raquette2 ]
        ] [ diff-raquette2: negate diff-raquette2
            either diff-raquette2 > vit-raquette2 [
                inc-raquette2/y: negate vit-raquette2
            ] [ inc-raquette2/y: negate diff-raquette2 ]
        ]
        pos-raquette2: pos-raquette2 + inc-raquette2
    ] [ if homme/data = true [
            ; clavier
            diff-raquette2: pos-clavier/y + (taille-balle / 2) - (pos-raquette2/y + (taille-raquette/y / 2))
            lift2: (-1 * diff-raquette2) / coeff-lift
            pos-raquette2: pos-clavier
        ] 
        if machine/data = true [
            ; machine
            diff-raquette2: pos-balle/y + (taille-balle / 2) - (pos-raquette2/y + (taille-raquette/y / 2))
            lift2: (-1 * diff-raquette2) / coeff-lift
            either diff-raquette2 >= 0 [
                either diff-raquette2 > vit-raquette2 [
                    inc-raquette2/y: vit-raquette2
                ] [ inc-raquette2/y: diff-raquette2 ]
            ] [ diff-raquette2: negate diff-raquette2
                either diff-raquette2 > vit-raquette2 [
                    inc-raquette2/y: negate vit-raquette2
                ] [ inc-raquette2/y: negate diff-raquette2 ]
            ]
            pos-raquette2: pos-raquette2 + inc-raquette2
        ]
    ]

    ; gestion de la balle
    if any [ ((pos-balle/y + taille-balle) > taille-ecran/y) (pos-balle/y < 0) ] [
        inc-balle/y: negate inc-balle/y
    ]
    pos-balle: pos-balle + inc-balle

    ] [
    ; sinon rseau
    ; gestion de la connexion
    gestion-connexion
    ]

    ; dans tous les cas, affichage de l'ensemble
    clearcadre-jeu/effect/draw
    append cadre-jeu/effect/draw reduce [
        'image pos-raquette1 raquette 0.0.0
    ]
    append cadre-jeu/effect/draw reduce [
        'image pos-raquette2 raquette 0.0.0
    ]
    append cadre-jeu/effect/draw reduce [
        'image pos-balle balle 0.0.0
    ]
    show cadre-jeu
]


gestion-partie: does [
    ; gestion de la partie
    ; si pas de rseau
    if reseau/data = false [

    ; gestion de la raquette1
    if all [
        ((pos-balle/x + taille-balle) >= pos-raquette1/x)
        ((pos-balle/x + taille-balle) < (taille-ecran/x - 20))
        ((pos-balle/y + taille-balle) >= pos-raquette1/y)
        (pos-balle/y <= (pos-raquette1/y + taille-raquette/y)) ] [
        ; retour
        inc-balle/x: negate inc-balle/x
        ; effet lift
        inc-balle/y: inc-balle/y + lift1
    ]
    if (pos-balle/x + taille-balle) > taille-ecran/x [
        ; remise en jeu (balle au centre)
        pos-balle: depart-balle
        inc-balle: negate init-inc-balle
        score2: score2 + 1
    ]

    ; gestion de la raquette2
    if all [
        (pos-balle/x <= (pos-raquette2/x + taille-raquette/x))
        (pos-balle/x > 0)
        ((pos-balle/y + taille-balle) >= pos-raquette2/y)
        (pos-balle/y <= (pos-raquette2/y + taille-raquette/y)) ] [
        ; retour
        inc-balle/x: negate inc-balle/x
        ; effet lift
        inc-balle/y: inc-balle/y + lift2
    ]
    if pos-balle/x < 0 [
        ; remise en jeu (balle au centre)
        pos-balle: depart-balle
        inc-balle: init-inc-balle
        score1: score1 + 1
    ]
    ]

    ; dans tous les cas, gestion des scores
    str-score1/text: to-string score1
    show str-score1
    str-score2/text: to-string score2
    show str-score2
    if any [ (score1 >= score-max) (score2 >= score-max) ] [
        either score1 >= score-max [
            vainqueur/text: "PLAYER 1 WINS !"
        ] [ vainqueur/text: "PLAYER 2 WINS !"]
        show vainqueur
        resultat/text: reduce [ "Player2: " :str-score2/text " - Player1: " :str-score1/text ]
        show resultat
        remove-event-func :evenements
        view game-over
    ]
]


ecran-reglages: center-face layout [
    backdrop effect [ gradient 1x1 255.255.255 0.0.0 ]
    style button button with [ effect: [ gradient 1x1 127.127.127 0.0.0 ] ]
    b: image %banner.jpg
    ; rglage des options
    h1 "SETTINGS"
    across

    ; score max.
    h3 "max. score"
    opt-score-max: field right 30x20 to-string score-max feel [ redraw: engage: none ]
    return
    barre-score-max: slider 210x9 [
        opt-score-max/text: mold to-integer 98 * barre-score-max/data + 1
        show opt-score-max
        score-max: to-integer opt-score-max/text
    ]
    return

    ; vitesse de la raquette1
    h3 "player1 racket speed"
    opt-vit-raquette1: field right 30x20 to-string vit-raquette1 feel [ redraw: engage: none ]
    return
    barre-vit-raquette1: slider 210x9 [
        opt-vit-raquette1/text: mold to-integer 140 * barre-vit-raquette1/data + 10
        show opt-vit-raquette1
        vit-raquette1: to-integer opt-vit-raquette1/text
    ]
    return

    ; vitesse de la raquette2
    h3 "player2 racket speed"
    opt-vit-raquette2: field right 30x20 to-string vit-raquette2 feel [ redraw: engage: none ]
    return
    barre-vit-raquette2: slider 210x9 [
        opt-vit-raquette2/text: mold to-integer 140 * barre-vit-raquette2/data + 10
        show opt-vit-raquette2
        vit-raquette2: to-integer opt-vit-raquette2/text
    ]
    return

    ; vitesse de la balle
    h3 "ball speed"
    opt-init-inc-balle: field right 30x20 to-string init-inc-balle/x feel [ redraw: engage: none ]
    return
    barre-init-inc-balle: slider 210x9 [
        opt-init-inc-balle/text: mold to-integer 40 * barre-init-inc-balle/data + 10
        show opt-init-inc-balle
        init-inc-balle/x: to-integer opt-init-inc-balle/text
    ]
    return

    ; coeff. du lift
    h3 "lift coeff."
    opt-coeff-lift: field right 30x20 to-string coeff-lift feel [ redraw: engage: none ]
    return
    barre-coeff-lift: slider 210x9 [
        opt-coeff-lift/text: mold to-integer 4 * barre-coeff-lift/data + 1
        show opt-coeff-lift
        coeff-lift: 6 - (to-integer opt-coeff-lift/text) 
    ]
    return

    ; joueur
    h3 "you (mouse)"
    return
    player2: radio of 'joueur [ pos-souris: pos-raquette2 pos-clavier: pos-raquette1 ] text h3 "player2"
    player1: radio of 'joueur [ pos-souris: pos-raquette1 pos-clavier: pos-raquette2 ] text h3 "player1"
    return

    ; adversaire
    h3 "against"
    return
    homme: radio of 'adversaire [
        show barre-vit-raquette1
        show barre-vit-raquette2
        show barre-init-inc-balle
        show barre-coeff-lift
        hide titre-serveur
        hide titre-ip hide champ-ip
        hide titre-port hide champ-port
        show bouton-player1
    ] text h3 "human (local, keyboard)"
    return
    machine: radio of 'adversaire [
        show barre-vit-raquette1
        show barre-vit-raquette2
        show barre-init-inc-balle
        show barre-coeff-lift
        hide titre-serveur
        hide titre-ip hide champ-ip
        hide titre-port hide champ-port
        show bouton-player1
    ] text h3 "machine (local)"
    return
    reseau: radio of 'adversaire [
        opt-vit-raquette1/text: "50"
        show opt-vit-raquette1
        vit-raquette1: to-integer opt-vit-raquette1/text
        hide barre-vit-raquette1
        opt-vit-raquette2/text: "50"
        show opt-vit-raquette2
        vit-raquette2: to-integer opt-vit-raquette2/text
        hide barre-vit-raquette2
        opt-init-inc-balle/text: "30"
        show opt-init-inc-balle
        init-inc-balle/x: to-integer opt-init-inc-balle/text
        hide barre-init-inc-balle
        opt-coeff-lift/text: "3"
        show opt-coeff-lift
        coeff-lift: 6 - (to-integer opt-coeff-lift/text) 
        hide barre-coeff-lift
        show titre-serveur
        show titre-ip show champ-ip
        show titre-port show champ-port
        hide bouton-player1
    ] text h3 "human (remote)"
    return

    ; serveur
    titre-serveur: h3 "server (if remote)"
    return
    titre-ip: h3 "IP"
    champ-ip: field 95x20 [ ip: to-tuple champ-ip/text ]
    titre-port: h3 "port"
    champ-port: field 35x20 [ port: to-integer champ-port/text ]
    return

    ; lancement du jeu
    bouton-player2: button "Start Player2" [
        if any [ (homme/data = true) (machine/data = true) (reseau/data = true) ] [
        inc-balle/x: init-inc-balle/x
        if reseau/data = true [ demarrage-connexion demarrage-partie ]
        hide-popup
        do [ insert-event-func :evenements ]
        view ecran-jeu
        ]
    ]
    bouton-player1: button "Start Player1" [
        if any [ (homme/data = true) (machine/data = true) (reseau/data = true) ] [
        inc-balle/x: negate init-inc-balle/x
        if reseau/data = true [ demarrage-connexion demarrage-partie ]
        hide-popup
        do [ insert-event-func :evenements ]
        view ecran-jeu
        ]
    ]
]


ecran-jeu: center-face layout/size [
    ; prparation de l'cran de jeu
    backdrop fond-ecran
    origin 0x0

    ; barre de titre & score
    panel taille-titre [ 
        backtile 0.0.0 effect [ gradient 0x1 255.255.255 ]
        origin 0x0
        across
        tabs [ 90 ((taille-titre/x / 2) - 50) (taille-titre/x - 190) ]
        tab
        vh1 "Player2:" 255.255.255
        str-score2: vh1 "00" 255.255.255
        tab
        vh1 "PuReP0NG" 255.255.255
        tab
        vh1 "Player1:" 255.255.255
        str-score1: vh1 "00" 255.255.255
    ]

    ; cadre de jeu
    cadre-jeu: box taille-ecran rate 0:0:0.01 feel [
        engage: func [ f a e ] [
            ; timer
            if a = 'time [
                ; gestion de pong
                gestion-pong
                ; gestion de la partie
                gestion-partie
            ]
        ]
    ] effect [ draw [] ]
] taille-ecran


evenements: func [ face event ] [
    ; gestion des vnements
    switch event/type [
        ; souris
        move [
            pos-souris: event/offset
            if pos-souris/y < 0 [ pos-souris/y: 0 ]
            if pos-souris/y > taille-ecran/y [ pos-souris/y: taille-ecran/y ]
        ]
        ; clavier
        key [
            switch event/key [
                ; raquette au clavier
                up [
                    either player1/data = true [
                        if pos-clavier/y > (0 - (taille-raquette/y / 2)) [
                            pos-clavier/y: pos-clavier/y - vit-raquette2
                        ]
                    ] [ if pos-clavier/y > (0 - (taille-raquette/y / 2)) [
                            pos-clavier/y: pos-clavier/y - vit-raquette1
                        ] ]
                ]
                down [
                    either player1/data = true [
                        if pos-clavier/y < (taille-ecran/y - taille-raquette/y) [
                            pos-clavier/y: pos-clavier/y + vit-raquette2
                        ]
                    ] [ if pos-clavier/y < (taille-ecran/y - taille-raquette/y) [
                            pos-clavier/y: pos-clavier/y + vit-raquette1
                        ] ]
                ]
                ; rglage des options (balle au centre)
                #"s" [
                        if reseau/data = false [
                            pos-balle: depart-balle
                            inc-balle: init-inc-balle
                            remove-event-func :evenements
                            view ecran-reglages
                        ]
                ]
                #"S" [
                        if reseau/data = false [
                            pos-balle: depart-balle
                            inc-balle: init-inc-balle
                            remove-event-func :evenements
                            view ecran-reglages
                        ]
                ]
                ; pause
                #"p" [
                        if reseau/data = false [
                            remove-event-func :evenements
                            view pause
                        ]
                ]
                #"P" [
                        if reseau/data = false [
                            remove-event-func :evenements
                            view pause
                        ]
                ]
                ; quitter le jeu
                #"q" [
                    if reseau/data = true [ close connexion ]
                    quit
                ]
                #"Q" [
                    if reseau/data = true [ close connexion ]
                    quit
                ]
                #"^(ESC)" [
                    if reseau/data = true [ close connexion ]
                    quit
                ]
            ]
        ]
    ]
    return event
]


pause: center-face layout/size [
    backdrop effect [ gradient 1x1 255.255.255 0.0.0 ]
    style button button with [ effect: [ gradient 1x1 127.127.127 0.0.0 ] ]
    ; pause
    h1 175x25 center "PAUSE"
    h3 175x25 center ""

    ; continuer le jeu
    button 175x20 center "Continue" [
        hide-popup
        do [ insert-event-func :evenements ]
        view ecran-jeu
    ]
] 215x125


game-over: center-face layout/size [
    backdrop effect [ gradient 1x1 255.255.255 0.0.0 ]
    style button button with [ effect: [ gradient 1x1 127.127.127 0.0.0 ] ]
    ; message vainqueur & rsultat
    vainqueur: h1 175x25 center "PLAYER X WINS !"
    resultat: h3 175x25 center "Player2: XX - Player1: XX"

    ; nouveau jeu
    button 175x20 center "New Game" [
        score1: 0
        score2: 0
        hide-popup
        if reseau/data = true [ quit ]
        do [ insert-event-func :evenements ]
        view ecran-jeu
    ]
] 215x125


intro: center-face layout [
    ; intro
    backdrop effect [ gradient 1x1 255.255.255 0.0.0 ]
    i: image %intro.jpg
]


; lancement du jeu
; intro
view intro

; rglage des options
player1/data: true
homme/data: false
machine/data: false
reseau/data: false
remove-event-func :evenements
view ecran-reglages

