rebol [
    title: "Serveur PuReP0NG"
    version: 0.7
    date: 23/08/2003
    author: "Sbastien 'Jedi' Jeudy"
    email: s.jeudy@libertysurf.fr
    url: http://reboleur.free.fr
]


; variables gnrales
taille-ecran: 640x480
;taille-ecran: 800x600
offset-souris: 20
taille-raquette: 24x100
coeff-lift: 3
donnees-recues: []
donnees-P1: [ "P1" "NON" "0x0" ]
donnees-P2: [ "P2" "NON" "0x0" ]

; variables de la raquette1
pos-raquette1: 0x0
pos-raquette1/x: taille-ecran/x - 40
pos-raquette1/y: (taille-ecran/y / 2) - (taille-raquette/y / 2)
pos-souris: pos-raquette1
diff-raquette1: 0
inc-raquette1: 0x0
vit-raquette1: 50
score1: 0

; variables de la raquette2
pos-raquette2: 15x0
pos-raquette2/y: pos-raquette1/y
diff-raquette2: 0
inc-raquette2: 0x0
vit-raquette2: 50
score2: 0

; variables de la balle
depart-balle: 0x0
depart-balle/x: taille-ecran/x / 2
depart-balle/y: pos-raquette1/y
pos-balle: depart-balle
taille-balle: 45
init-inc-balle: 30x0
inc-balle: init-inc-balle


gestion-pong: does [
    ; gestion de pong
    ; gestion de la raquette1
    if (first donnees-recues) = "P1" [
        ; souris
        diff-raquette1: pos-souris/y + offset-souris - (pos-raquette1/y + taille-raquette/y)
        lift1: (-1 * diff-raquette1) / coeff-lift
        either diff-raquette1 >= 0 [
            either diff-raquette1 > vit-raquette1 [
                inc-raquette1/y: vit-raquette1
            ] [ inc-raquette1/y: diff-raquette1 ]
        ] [ diff-raquette1: negate diff-raquette1
            either diff-raquette1 > vit-raquette1 [
                inc-raquette1/y: negate vit-raquette1
            ] [ inc-raquette1/y: negate diff-raquette1 ]
        ]
        pos-raquette1: pos-raquette1 + inc-raquette1
    ]

    ; gestion de la raquette2
    if (first donnees-recues) = "P2" [
        ; souris
        diff-raquette2: pos-souris/y + offset-souris - (pos-raquette2/y + taille-raquette/y)
        lift2: (-1 * diff-raquette2) / coeff-lift
        either diff-raquette2 >= 0 [
            either diff-raquette2 > vit-raquette2 [
                inc-raquette2/y: vit-raquette2
            ] [ inc-raquette2/y: diff-raquette2 ]
        ] [ diff-raquette2: negate diff-raquette2
            either diff-raquette2 > vit-raquette2 [
                inc-raquette2/y: negate vit-raquette2
            ] [ inc-raquette2/y: negate diff-raquette2 ]
        ]
        pos-raquette2: pos-raquette2 + inc-raquette2
    ]

    ; gestion de la balle
    if any [ ((pos-balle/y + taille-balle) > taille-ecran/y) (pos-balle/y < 0) ] [
        inc-balle/y: negate inc-balle/y
    ]
    pos-balle: pos-balle + inc-balle
]


gestion-partie: does [
    ; gestion de la partie
    ; gestion de la raquette1
    if all [
        ((pos-balle/x + taille-balle) >= pos-raquette1/x)
        ((pos-balle/x + taille-balle) < (taille-ecran/x - 20))
        ((pos-balle/y + taille-balle) >= pos-raquette1/y)
        (pos-balle/y <= (pos-raquette1/y + taille-raquette/y)) ] [
        ; retour
        inc-balle/x: negate inc-balle/x
        ; effet lift
        inc-balle/y: inc-balle/y + lift1
    ]
    if (pos-balle/x + taille-balle) > taille-ecran/x [
        ; remise en jeu (balle au centre)
        pos-balle: depart-balle
        inc-balle: negate init-inc-balle
        score2: score2 + 1
    ]

    ; gestion de la raquette2
    if all [
        (pos-balle/x <= (pos-raquette2/x + taille-raquette/x))
        (pos-balle/x > 0)
        ((pos-balle/y + taille-balle) >= pos-raquette2/y)
        (pos-balle/y <= (pos-raquette2/y + taille-raquette/y)) ] [
        ; retour
        inc-balle/x: negate inc-balle/x
        ; effet lift
        inc-balle/y: inc-balle/y + lift2
    ]
    if pos-balle/x < 0 [
        ; remise en jeu (balle au centre)
        pos-balle: depart-balle
        inc-balle: init-inc-balle
        score1: score1 + 1
    ]
]


; dmarrage du serveur PuReP0NG
port: ask "Port? "
io-port: open to-url join "udp://:" [ port ]
print ""
print "PuReP0NG Server started."
print "..."


; traitement des donnes
forever [
    wait io-port

    ; donnes reues par le serveur
    donnees-recues-str: (copy io-port)
;    print donnees-recues-str
    clear donnees-recues
    donnees-recues: parse (copy donnees-recues-str) "_"
    either (first donnees-recues) = "P1" [
        donnees-P1: parse (copy donnees-recues-str) "_"
        pos-souris: to-pair (third donnees-P1)
    ] [
        donnees-P2: parse (copy donnees-recues-str) "_"
        pos-souris: to-pair (third donnees-P2)
    ]

    if all [ ((second donnees-P1) = "CNX") ((second donnees-P2) = "CNX") ] [
        ; gestion de pong
        gestion-pong
        ; gestion de la partie
        gestion-partie
    ]

    ; donnes renvoyes par le serveur
    donnees-serveur-str: reduce [
        "P1_" (second donnees-P1) "_"
        "P2_" (second donnees-P2) "_"
        (to-string pos-raquette1) "_"
        (to-string pos-balle) "_"
        (to-string pos-raquette2) "_"
        (to-string score1) "_"
        (to-string score2)
    ]
;    print donnees-serveur-str
    insert io-port donnees-serveur-str
]


; arrt du serveur
close io-port
print "PuReP0NG Server closed."

